#!/usr/bin/perl

## use strict;
## use warnings;
use Sys::Syslog qw(:DEFAULT setlogsock);


our $syslog_socktype = 'unix'; # inet, unix, stream, console
our $syslog_facility="mail";
our $syslog_options="pid";
our $syslog_priority="info";
our %attr = ();
our $option;
our $recipol;
our $action;
our $lokhaykhacer;
our $instanmemo;
our $verbose = 0;


###################################### CONFIGURATION VARIABLES ################################################
###############################################################################################################




sub smtpd_access_policy_quota {
			my $rutamaildir="";
			my $quehagoconelcorreo="";
			my $quota="";
			my $used="";
			my $restante="";
			my @comprobacionesrutas=split(/,/,$attr{"rutas"});
   			syslog $syslog_priority, "Mailboxes to check : @comprobacionesrutas" if ($verbose == 1);
			foreach $rutamaildir (@comprobacionesrutas)
			   {
				my $procesar=0;
				syslog $syslog_priority, "Path to check now : $rutamaildir" if ($verbose==2);
				open(QF, '<', "$rutamaildir") or $procesar=1;
				if ($procesar==1)
				{
				syslog $syslog_priority, "Unable to open path $rutamaildir";
				$quehagoconelcorreo="A";
				}
				elsif ($procesar==0)
				{
				my ($firstln, $quota, $used);
		        	while (<QF>) {
			        my $line = $_;
		                if (! $firstln) {
                                         $firstln = 1;
					 syslog $syslog_priority, "Corrup quota file $rutamaildir"
                                         unless ($line =~ /^(\d+)S/);
					 $quehagoconelcorreo="A"
					 unless ($line =~ /^(\d+)S/);
					 $quota="nosepuede"
					 		unless ($line =~ /^(\d+)S/);
					 		last unless ($line =~ /^(\d+)S/);
                     $quota = $1 if ($line =~ /^(\d+)S/);
                     next;
                                }
			        syslog $syslog_priority, "Corrupt quota file $rutamaildir"
                         	unless ($line =~ /\s*(-?\d+)/);
				$quehagoconelcorreo="A"
                         	unless ($line =~ /\s*(-?\d+)/);
			        $used="nosepuede"
                         	unless ($line =~ /\s*(-?\d+)/);
				last unless ($line =~ /\s*(-?\d+)/);

				$used += $1 if ($line =~ /\s*(-?\d+)/);
				}
				close(QF);
				

				if (($quota ne "nosepuede") && ($used ne "nosepuede"))
				{
				my $quotalog = $quota/1024;
				my $usedlog = $used/1024;
		 		syslog $syslog_priority, "Mailbox size is : $quotalog KB" if ($verbose==2);	
		 		syslog $syslog_priority, "Mailbox used space is : $usedlog KB" if ($verbose==2);
				my $restante = $quota - $used;
				my $restantelog = $restante/1024;
		        syslog $syslog_priority, "Free space in mailbox : $restantelog KB" if ($verbose==2);
				my $sizepolitica = $attr{"size"};
				$sizepolitica = $sizepolitica * 1024;
				my $sizepoliticalog = $sizepolitica/1024;
				syslog $syslog_priority, "Entering mail size is : $sizepoliticalog KB" if ($verbose==2);
				if ($sizepolitica > $restante)
				{
  					$quehagoconelcorreo="R"; 
				}
				else
				{
					$quehagoconelcorreo="A";
				}
				}
			

				if ($quehagoconelcorreo eq "R")
                	        {
                	       	last;
				## break;
				}      

			        }	
   			}
			return "$quehagoconelcorreo";	
	}


sub fatal_exit {
    my($first) = shift(@_);
    syslog "err", "fatal: $first", @_;
    exit 1;
}

setlogsock $syslog_socktype;
openlog $0, $syslog_options, $syslog_facility;

while ($option = shift(@ARGV)) {
    if ($option eq "-v") {
	$verbose = 1;
    } elsif ($option eq "-vv") {
	$verbose = 2;
    }
      else 
    {
	syslog $syslog_priority, "Invalid option: %s. Usage: %s [-v] or [-vv]",
		$option, $0;
	exit 1;
    }
}


select((select(STDOUT), $| = 1)[0]);

while (<STDIN>) {
    if (/([^=]+)=(.*)\n/) {
	$attr{substr($1, 0, 512)} = substr($2, 0, 512);
        } elsif ($_ eq "\n") {
	if ($verbose) {
	    for (keys %attr) {
		syslog $syslog_priority, "On mailboxes daemon : %s=%s", $_, $attr{$_} if ($verbose == 1);
	    }
	}
	fatal_exit "unrecognized request type: '%s'", $attr{request}
	    unless $attr{"request"} eq "smtpd_access_policy";
	$action = smtpd_access_policy_quota();
	syslog $syslog_priority, "Action mailboxes daemon: %s", $action if ($verbose == 1);
	print STDOUT "$action\n";
	%attr = ();
    } else {
	chop;
	syslog $syslog_priority, "warning: ignoring garbage: %.100s", $_;
    }
}
