#!/usr/bin/perl

## use strict;
## use warnings;
use Sys::Syslog qw(:DEFAULT setlogsock);


our $syslog_socktype = 'unix'; # inet, unix, stream, console
our $syslog_facility="mail";
our $syslog_options="pid";
our $syslog_priority="info";
our %attr = ();
our $option;
our $recipol;
our $action;
our $lokhaykhacer;
our $instanmemo;
our $abridor;
our $verbose=0;

###################################### CONFIGURATION VARIABLES ################################################
###############################################################################################################




sub smtpd_access_policy_quota {
			my $rutamaildir="";
			my $quehagoconelcorreo="";
			my @comprobacionesrutas=split(/,/,$attr{"rutas"});
			syslog $syslog_priority, "Mailboxes to check : @comprobacionesrutas" if ($verbose==1 || $verbose==2);
			foreach $rutamaildir (@comprobacionesrutas)
			   {
				my $procesar=0;
				syslog $syslog_priority, "Path to check at the moment : $rutamaildir" if ($verbose==2);
				open(QF, '<', "$rutamaildir") or $procesar=1;
				if ($procesar==1)
				{
				syslog $syslog_priority, "Path $rutamaildir unable to open";
				$quehagoconelcorreo="A";
				}
				elsif ($procesar==0)
				{
				my ($firstln, $quota, $used);
		        	while (<QF>) {
			        my $line = $_;
		                if (! $firstln) {
			                 $firstln = 1;
			                 syslog $syslog_priority, "Corrup quota file $rutamaildir"
		                         unless ($line =~ /^(\d+)/);
					 $quehagoconelcorreo="A"
		                         unless ($line =~ /^(\d+)/);
					 $used="nosepuede"
					 unless ($line =~ /^(\d+)/);
				         last unless ($line =~ /^(\d+)/);
					 $used = $1 if ($line =~ /^(\d+)/);
					 $used = $used/1024 if (($used!=0) && ($line =~ /^(\d+)/)); 	
			                 next;
		         	}
				syslog $syslog_priority, "Corrup quota file $rutamaildir"
		         	unless ($line =~ /^(\d+)/);
				$quehagoconelcorreo="A"
	                        unless ($line =~ /^(\d+)/);
				$quota="nosepuede" 
				unless ($line =~ /^(\d+)/);
				last unless ($line =~ /^(\d+)/);
		         	$quota = $1 if ($line =~ /^(\d+)/);
		        	}
				close(QF);
				
			        if (($quota ne "nosepuede") && ($used ne "nosepuede"))
                                   { 	
					syslog $syslog_priority, "Mailbox size is : $quota" if ($verbose==2);	
		 			syslog $syslog_priority, "Used space in mailbox : $used" if ($verbose==2);
					my $restante = $quota - $used;
		        		syslog $syslog_priority, "Free space in mailbox : $restante" if ($verbose==2);
					my $sizepolitica = $attr{"size"};
					syslog $syslog_priority, "Entering mail size : $sizepolitica KB" if ($verbose==2);
					if ($sizepolitica > $restante)
					{
  						$quehagoconelcorreo="R"; 
					}
					else
					{
						$quehagoconelcorreo="A";
					}

					if ($quehagoconelcorreo eq "R")
                	        	{
                	       		last;
					## break;
					}      

				   }	
				}

		}
		return "$quehagoconelcorreo";	
}



sub fatal_exit {
    my($first) = shift(@_);
    syslog "err", "fatal: $first", @_;
    exit 1;
}

setlogsock $syslog_socktype;
openlog $0, $syslog_options, $syslog_facility;

while ($option = shift(@ARGV)) {
    if ($option eq "-v") {
	$verbose = 1;
    } elsif ($option eq "-vv") {
	$verbose = 2;
    }
      else 
    {
	syslog $syslog_priority, "Invalid option: %s. Usage: %s [-v] or [-vv]",
		$option, $0;
	exit 1;
    }
}

select((select(STDOUT), $| = 1)[0]);

while (<STDIN>) {
    if (/([^=]+)=(.*)\n/) {
	$attr{substr($1, 0, 512)} = substr($2, 0, 512);
        } elsif ($_ eq "\n") {
	if ($verbose==1 || $verbose==2) {
	    for (keys %attr) {
		syslog $syslog_priority, "On mailboxes daemon : %s=%s", $_, $attr{$_};
	    }
	}
	fatal_exit "unrecognized request type: '%s'", $attr{request}
	    unless $attr{"request"} eq "smtpd_access_policy";
	$action = smtpd_access_policy_quota();
	syslog $syslog_priority, "Action Postfix-Quota-Reject mailboxes daemon : %s", $action if $verbose;
	print STDOUT "$action\n";
	%attr = ();
    } else {
	chop;
	syslog $syslog_priority, "warning: ignoring garbage: %.100s", $_;
    }
}
